import * as Three from 'three';

export type Directions = {
    directionX: number,
    directionY: number,
    directionZ: number,
};

function to_rad(degree: number): number {
    return (Math.PI / 180) * degree;
}
export function apply_direction(direction: Directions, _vector?: Three.Vector3): Three.Vector3 {
    const vector = _vector ?? new Three.Vector3(1,0,0);
    return vector
    .applyAxisAngle(new Three.Vector3(1, 0, 0), to_rad(direction.directionX))
    .applyAxisAngle(new Three.Vector3(0, 1, 0), to_rad(direction.directionY))
    .applyAxisAngle(new Three.Vector3(0, 0, 1), to_rad(direction.directionZ));
}
