import { writable } from "svelte/store";

type Configuration = {
    directionX: number,
    directionY: number,
    directionZ: number,
    id?: number,
    ledcount: number,
    tags: string,
}


function createSettingsStore() {
    const store = writable<Promise<Configuration[]>>();
    const loaded = writable<boolean>(false);
    return {
        async getData(force = false) {
            let loadedV = false;
            loaded.subscribe((v) => loadedV = v)();
            if (loadedV && !force)
                return;
            store.set(new Promise(() => { return; }));
            const request = await fetch('http://aether:3000/configure');
            store.set(request.json());
            loaded.set(true);
        },
        ...store,
    };
}

export const setStore = createSettingsStore();
